#ifndef PTR32_HPP_
#define PTR32_HPP_
#define ptr32_hpp_version	  "$Revision: 1.2 $"

class Ptr32{
	uint32_t id;
public:
	static const uint32_t MAX_ID 	= max32 >> 1;
	static const uint32_t Null		= max32;
	explicit Ptr32(uint32_t idx=Null):id(idx){}

	bool isNull() const	{return id== Null;}
	uint32_t idx() const{return id;}

	Ptr32& operator++()				{++id;return *this;}
	Ptr32& operator+=(const int& i)	{id+=i;return *this;}
	//Ptr32  operator++(int d){Ptr32 r=*this;++id;return r;}

	friend bool operator==(const Ptr32& a, const Ptr32& b);
	friend bool operator!=(const Ptr32& a, const Ptr32& b);
	friend bool operator<=(const Ptr32& a, const Ptr32& b);
	friend bool operator>=(const Ptr32& a, const Ptr32& b);
	friend bool operator<(const Ptr32& a, const Ptr32& b);
	friend Ptr32 operator+(const Ptr32& p, const uint32_t& a);
	friend Ptr32 operator-(const Ptr32& p, const uint32_t& a);
	friend uint32_t operator-(const Ptr32& g, const Ptr32& s);
	friend class MemPoolA;
	friend class MemPoolP;
};

inline Ptr32 operator+(const Ptr32& p, const uint32_t& a){ asrt(!p.isNull()||a==0);
	return Ptr32(p.id + a);
}

inline Ptr32 operator-(const Ptr32& p, const uint32_t& a){ asrt(!p.isNull()||a==0); asrt(p.id >= a);
	return Ptr32(p.id - a);
}

inline uint32_t operator-(const Ptr32& g, const Ptr32& s){ asrt(g.idx()>=s.idx());
	return g.idx()-s.idx();
}

inline bool operator==(const Ptr32& a, const Ptr32& b){
	return a.id==b.id;}

inline bool operator!=(const Ptr32& a, const Ptr32& b){
	return a.id!=b.id;}

inline bool operator<=(const Ptr32& a, const Ptr32& b){
	return a.id<=b.id;}


inline bool operator>=(const Ptr32& a, const Ptr32& b){
	return a.id>=b.id;}

inline bool operator<(const Ptr32& a, const Ptr32& b){
	return a.id<b.id;}



#endif /* PTR32_HPP_ */
